Index: trunk/platforms/tsarv4_generic_mmu/tsarv4_cluster_mmu/caba/source/src/tsarv4_cluster_mmu.cpp
===================================================================
--- trunk/platforms/tsarv4_generic_mmu/tsarv4_cluster_mmu/caba/source/src/tsarv4_cluster_mmu.cpp	(revision 234)
+++ trunk/platforms/tsarv4_generic_mmu/tsarv4_cluster_mmu/caba/source/src/tsarv4_cluster_mmu.cpp	(revision 247)
@@ -14,31 +14,31 @@
                         size_t          y_id,
                         size_t          cluster_id,
-                        const   	soclib::common::MappingTable &mtd,
-                        const   	soclib::common::MappingTable &mtc, 
-                        const   	soclib::common::MappingTable &mtx, 
+                        const           soclib::common::MappingTable &mtd,
+                        const           soclib::common::MappingTable &mtc, 
+                        const           soclib::common::MappingTable &mtx, 
                         size_t          x_width,
                         size_t          y_width,
-                        size_t		tgtid_memc,
-                        size_t		tgtid_xicu,
-                        size_t		tgtid_fbuf,
-                        size_t		tgtid_mtty,
-                        size_t		tgtid_brom,
-                        size_t		tgtid_bdev,
-                        size_t		tgtid_mdma,
-                        size_t		memc_ways,
-                        size_t		memc_sets,
-                        size_t		l1_i_ways,
-                        size_t		l1_i_sets,
-                        size_t		l1_d_ways,
-                        size_t		l1_d_sets,
-                        size_t		xram_latency,
+                        size_t          tgtid_memc,
+                        size_t          tgtid_xicu,
+                        size_t          tgtid_fbuf,
+                        size_t          tgtid_mtty,
+                        size_t          tgtid_brom,
+                        size_t          tgtid_bdev,
+                        size_t          tgtid_mdma,
+                        size_t          memc_ways,
+                        size_t          memc_sets,
+                        size_t          l1_i_ways,
+                        size_t          l1_i_sets,
+                        size_t          l1_d_ways,
+                        size_t          l1_d_sets,
+                        size_t          xram_latency,
                         bool            io,
-                        size_t		xfb,
-                        size_t		yfb,
-                        char*		disk_name,
-                        size_t		block_size,
+                        size_t          xfb,
+                        size_t          yfb,
+                        char*           disk_name,
+                        size_t          block_size,
                         const Loader   &loader,
-                        uint32_t	frozen_cycles,
-                        uint32_t	debug_start_cycle,
+                        uint32_t        frozen_cycles,
+                        uint32_t        debug_start_cycle,
                         bool            debug_ok)
       : soclib::caba::BaseModule(insname),
@@ -55,6 +55,6 @@
         signal_dspin_rsp_g2l_c("signal_dspin_rsp_g2l_c"),
 
-	signal_vci_ini_d_bdev("signal_vci_ini_d_bdev"),
-	signal_vci_ini_d_mdma("signal_vci_ini_d_mdma"),
+        signal_vci_ini_d_bdev("signal_vci_ini_d_bdev"),
+        signal_vci_ini_d_mdma("signal_vci_ini_d_mdma"),
 
         signal_vci_tgt_d_memc("signal_vci_tgt_d_memc"),
@@ -86,5 +86,5 @@
 
         // on coherence network : local srcid[proc] in [0...nprocs-1]
-	// on coherence network : local srcid[memc] = nprocs
+        // on coherence network : local srcid[memc] = nprocs
 
 std::cout << "  - building proc_" << x_id << "_" << y_id << "-*" << std::endl;
@@ -97,18 +97,21 @@
                 sproc.str().c_str(),
                 cluster_id*nprocs + p,
-                mtd,				// Mapping Table Direct
-                mtc,				// Mapping Table Coherence
-                IntTab(cluster_id,p),    	// SRCID_D
-                IntTab(cluster_id,p),    	// SRCID_C
-                IntTab(cluster_id,p),    	// TGTID_C
-                8,				// ITLB ways
-                8,				// ITLB sets
-                8,				// DTLB ways
-                8,				// DTLB sets
-                l1_i_ways,l1_i_sets,16,  	// ICACHE size
-                l1_d_ways,l1_d_sets,16,      	// DCACHE size
-                4,				// WBUF width
-                4, 				// WBUF depth
-                frozen_cycles,			// max frozen cycles
+                mtd,                            // Mapping Table Direct
+                mtc,                            // Mapping Table Coherence
+                IntTab(cluster_id,p),           // SRCID_D
+                IntTab(cluster_id,p),           // SRCID_C
+                IntTab(cluster_id,p),           // TGTID_C
+                8,                              // ITLB ways
+                8,                              // ITLB sets
+                8,                              // DTLB ways
+                8,                              // DTLB sets
+                l1_i_ways,l1_i_sets,16,         // ICACHE size
+                l1_d_ways,l1_d_sets,16,         // DCACHE size
+                4,                              // WBUF width
+                4,                              // WBUF depth
+                x_width,                        // X Width
+                y_width,                        // Y Width
+                nprocs,                         // Memory Cache Local Id (coherence)
+                frozen_cycles,                  // max frozen cycles
                 debug_start_cycle,
                 debug_ok);
@@ -122,12 +125,12 @@
                    smemc.str().c_str(),
                    mtd, mtc, mtx,
-                   IntTab(cluster_id),           	// SRCID_X
-                   IntTab(cluster_id, nprocs),   	// SRCID_C
-                   IntTab(cluster_id, tgtid_memc),	// TGTID_D
-                   IntTab(cluster_id, nprocs),   	// TGTID_C
-                   memc_ways, memc_sets, 16,	 	// CACHE SIZE
-                   4096,     			 	// HEAP SIZE
-                   8,					// TRANSACTION TABLE DEPTH
-                   8,					// UPDATE TABLE DEPTH
+                   IntTab(cluster_id),                  // SRCID_X
+                   IntTab(cluster_id, nprocs),          // SRCID_C
+                   IntTab(cluster_id, tgtid_memc),      // TGTID_D
+                   IntTab(cluster_id, nprocs),          // TGTID_C
+                   memc_ways, memc_sets, 16,            // CACHE SIZE
+                   4096,                                // HEAP SIZE
+                   8,                                   // TRANSACTION TABLE DEPTH
+                   8,                                   // UPDATE TABLE DEPTH
                    debug_start_cycle,
                    debug_ok);
@@ -147,16 +150,16 @@
 std::cout << "  - building xicu_" << x_id << "_" << y_id << std::endl;
 
-        size_t  nhwi = 4;				// always 4 (or 9) ports, even if 
-        if( io == true ) nhwi = 9;			// there if less than 4 processors
+        size_t  nhwi = 4;                               // always 4 (or 9) ports, even if 
+        if( io == true ) nhwi = 9;                      // there if less than 4 processors
         std::ostringstream sicu;
         sicu << "xicu_" << x_id << "_" << y_id;
         xicu = new VciXicu<vci_param>(
                   sicu.str().c_str(),
-                  mtd,				  	// mapping table
-                  IntTab(cluster_id, tgtid_xicu),  	// TGTID_D
-                  0,					// number of timer IRQs
-                  nhwi,                          	// number of hard IRQs
-                  0,					// number of soft IRQs
-                  nprocs);				// number of output IRQs
+                  mtd,                                  // mapping table
+                  IntTab(cluster_id, tgtid_xicu),       // TGTID_D
+                  0,                                    // number of timer IRQs
+                  nhwi,                                 // number of hard IRQs
+                  0,                                    // number of soft IRQs
+                  nprocs);                              // number of output IRQs
 
 std::cout << "  - building dma_" << x_id << "_" << y_id << std::endl;
@@ -168,8 +171,8 @@
                    sdma.str().c_str(),
                    mtd,
-                   IntTab(cluster_id, nprocs),		// SRCID
-                   IntTab(cluster_id, tgtid_mdma),	// TGTID
-                   64,					// burst size
-                   nprocs);				// number of IRQs
+                   IntTab(cluster_id, nprocs),          // SRCID
+                   IntTab(cluster_id, tgtid_mdma),      // TGTID
+                   64,                                  // burst size
+                   nprocs);                             // number of IRQs
 
 std::cout << "  - building xbard_" << x_id << "_" << y_id << std::endl;
@@ -182,5 +185,5 @@
             nb_direct_initiators         = nprocs + 2;
             nb_direct_targets            = 7;
-	}
+        }
         std::ostringstream sd;
         sd << "xbard_" << x_id << "_" << y_id;
@@ -188,8 +191,8 @@
                     sd.str().c_str(),
                     mtd,
-                    IntTab(cluster_id),              	// cluster initiator index
-                    IntTab(cluster_id),              	// cluster target index
-                    nb_direct_initiators,           	// number of initiators
-                    nb_direct_targets);             	// number of targets      
+                    IntTab(cluster_id),                 // cluster initiator index
+                    IntTab(cluster_id),                 // cluster target index
+                    nb_direct_initiators,               // number of initiators
+                    nb_direct_targets);                 // number of targets      
         
 std::cout << "  - building xbarc_" << x_id << "_" << y_id << std::endl;
@@ -201,8 +204,8 @@
                     sc.str().c_str(),
                     mtc,
-                    IntTab(cluster_id),                	// cluster initiator index
-                    IntTab(cluster_id),                	// cluster target index
-                    nprocs + 1,                		// number of initiators
-                    nprocs + 1);               		// number of targets
+                    IntTab(cluster_id),                 // cluster initiator index
+                    IntTab(cluster_id),                 // cluster target index
+                    nprocs + 1,                         // number of initiators
+                    nprocs + 1);                        // number of targets
         
 std::cout << "  - building wrappers in cluster_" << x_id << "_" << y_id << std::endl;
@@ -213,6 +216,6 @@
         iniwrapperd = new VciVdspinInitiatorWrapper<vci_param,cmd_width,rsp_width>(
                           wid.str().c_str(),
-                          4,				// cmd fifo depth
-                          4);				// rsp fifo depth
+                          4,                            // cmd fifo depth
+                          4);                           // rsp fifo depth
 
         // direct target wrapper
@@ -221,6 +224,6 @@
         tgtwrapperd = new VciVdspinTargetWrapper<vci_param,cmd_width,rsp_width>(
                           wtd.str().c_str(),
-                          4,				// cmd fifo depth
-                          4);				// rsp fifo depth
+                          4,                            // cmd fifo depth
+                          4);                           // rsp fifo depth
 
         // coherence initiator wrapper
@@ -229,6 +232,6 @@
         iniwrapperc = new VciVdspinInitiatorWrapper<vci_param,cmd_width,rsp_width>(
                           wic.str().c_str(),
-                          4,				// cmd fifo depth
-                          4);				// rsp fifo depth
+                          4,                            // cmd fifo depth
+                          4);                           // rsp fifo depth
 
         // coherence target wrapper
@@ -237,6 +240,6 @@
         tgtwrapperc = new VciVdspinTargetWrapper<vci_param,cmd_width,rsp_width>(
                           wtc.str().c_str(),
-                          4,				// cmd fifo depth
-                          4);				// rsp fifo depth
+                          4,                            // cmd fifo depth
+                          4);                           // rsp fifo depth
 
 std::cout << "  - building cmdrouter_" << x_id << "_" << y_id << std::endl;
@@ -264,5 +267,5 @@
         // IO cluster components
         if ( io == true )
-	{
+        {
             brom = new VciSimpleRam<vci_param>(
                        "brom",
@@ -275,5 +278,5 @@
                        IntTab(cluster_id, tgtid_fbuf),
                        mtd,
-		       xfb, yfb); 
+                       xfb, yfb); 
 
             bdev = new VciBlockDeviceTsarV4<vci_param>(
@@ -290,5 +293,5 @@
                        mtd, 
                        "tty0", "tty1", "tty2", "tty3", NULL);
-	}
+        }
 
 std::cout << "  - all components constructed" << std::endl;
@@ -299,8 +302,8 @@
 
         // CMDROUTER and RSPROUTER
-        cmdrouter->p_clk                	(this->p_clk);
-        cmdrouter->p_resetn             	(this->p_resetn);
-        rsprouter->p_clk                	(this->p_clk);
-        rsprouter->p_resetn             	(this->p_resetn);
+        cmdrouter->p_clk                        (this->p_clk);
+        cmdrouter->p_resetn                     (this->p_resetn);
+        rsprouter->p_clk                        (this->p_clk);
+        rsprouter->p_resetn                     (this->p_resetn);
         for(int x = 0; x < 2; x++)
         {
@@ -314,77 +317,77 @@
         }
         
-        cmdrouter->p_out[0][4]  		(signal_dspin_cmd_g2l_d);
-        cmdrouter->p_out[1][4]  		(signal_dspin_cmd_g2l_c);
-        cmdrouter->p_in[0][4]   		(signal_dspin_cmd_l2g_d);
-        cmdrouter->p_in[1][4]   		(signal_dspin_cmd_l2g_c);
-
-        rsprouter->p_out[0][4]  		(signal_dspin_rsp_g2l_d);
-        rsprouter->p_out[1][4]  		(signal_dspin_rsp_g2l_c);
-        rsprouter->p_in[0][4]   		(signal_dspin_rsp_l2g_d);
-        rsprouter->p_in[1][4]   		(signal_dspin_rsp_l2g_c);
+        cmdrouter->p_out[0][4]                  (signal_dspin_cmd_g2l_d);
+        cmdrouter->p_out[1][4]                  (signal_dspin_cmd_g2l_c);
+        cmdrouter->p_in[0][4]                   (signal_dspin_cmd_l2g_d);
+        cmdrouter->p_in[1][4]                   (signal_dspin_cmd_l2g_c);
+
+        rsprouter->p_out[0][4]                  (signal_dspin_rsp_g2l_d);
+        rsprouter->p_out[1][4]                  (signal_dspin_rsp_g2l_c);
+        rsprouter->p_in[0][4]                   (signal_dspin_rsp_l2g_d);
+        rsprouter->p_in[1][4]                   (signal_dspin_rsp_l2g_c);
 
         // VCI/DSPIN WRAPPERS
-        iniwrapperd->p_clk			(this->p_clk);
-        iniwrapperd->p_resetn			(this->p_resetn);
-	iniwrapperd->p_vci			(signal_vci_l2g_d);
-	iniwrapperd->p_dspin_out		(signal_dspin_cmd_l2g_d);
-	iniwrapperd->p_dspin_in			(signal_dspin_rsp_g2l_d);
-
-        tgtwrapperd->p_clk			(this->p_clk);
-        tgtwrapperd->p_resetn			(this->p_resetn);
-	tgtwrapperd->p_vci			(signal_vci_g2l_d);
-	tgtwrapperd->p_dspin_out		(signal_dspin_rsp_l2g_d);
-	tgtwrapperd->p_dspin_in			(signal_dspin_cmd_g2l_d);
-
-        iniwrapperc->p_clk			(this->p_clk);
-        iniwrapperc->p_resetn			(this->p_resetn);
-	iniwrapperc->p_vci			(signal_vci_l2g_c);
-	iniwrapperc->p_dspin_out		(signal_dspin_cmd_l2g_c);
-	iniwrapperc->p_dspin_in			(signal_dspin_rsp_g2l_c);
-
-        tgtwrapperc->p_clk			(this->p_clk);
-        tgtwrapperc->p_resetn			(this->p_resetn);
-	tgtwrapperc->p_vci			(signal_vci_g2l_c);
-	tgtwrapperc->p_dspin_out		(signal_dspin_rsp_l2g_c);
-	tgtwrapperc->p_dspin_in			(signal_dspin_cmd_g2l_c);
+        iniwrapperd->p_clk                      (this->p_clk);
+        iniwrapperd->p_resetn                   (this->p_resetn);
+        iniwrapperd->p_vci                      (signal_vci_l2g_d);
+        iniwrapperd->p_dspin_out                (signal_dspin_cmd_l2g_d);
+        iniwrapperd->p_dspin_in                 (signal_dspin_rsp_g2l_d);
+
+        tgtwrapperd->p_clk                      (this->p_clk);
+        tgtwrapperd->p_resetn                   (this->p_resetn);
+        tgtwrapperd->p_vci                      (signal_vci_g2l_d);
+        tgtwrapperd->p_dspin_out                (signal_dspin_rsp_l2g_d);
+        tgtwrapperd->p_dspin_in                 (signal_dspin_cmd_g2l_d);
+
+        iniwrapperc->p_clk                      (this->p_clk);
+        iniwrapperc->p_resetn                   (this->p_resetn);
+        iniwrapperc->p_vci                      (signal_vci_l2g_c);
+        iniwrapperc->p_dspin_out                (signal_dspin_cmd_l2g_c);
+        iniwrapperc->p_dspin_in                 (signal_dspin_rsp_g2l_c);
+
+        tgtwrapperc->p_clk                      (this->p_clk);
+        tgtwrapperc->p_resetn                   (this->p_resetn);
+        tgtwrapperc->p_vci                      (signal_vci_g2l_c);
+        tgtwrapperc->p_dspin_out                (signal_dspin_rsp_l2g_c);
+        tgtwrapperc->p_dspin_in                 (signal_dspin_cmd_g2l_c);
 
         // CROSSBAR direct
-        xbard->p_clk                  		(this->p_clk);
-        xbard->p_resetn                 	(this->p_resetn);
-        xbard->p_initiator_to_up        	(signal_vci_l2g_d);
-        xbard->p_target_to_up           	(signal_vci_g2l_d);
+        xbard->p_clk                            (this->p_clk);
+        xbard->p_resetn                         (this->p_resetn);
+        xbard->p_initiator_to_up                (signal_vci_l2g_d);
+        xbard->p_target_to_up                   (signal_vci_g2l_d);
           
-        xbard->p_to_target[tgtid_memc]  	(signal_vci_tgt_d_memc);
-        xbard->p_to_target[tgtid_xicu]  	(signal_vci_tgt_d_xicu);
-        xbard->p_to_target[tgtid_mdma]  	(signal_vci_tgt_d_mdma);
+        xbard->p_to_target[tgtid_memc]          (signal_vci_tgt_d_memc);
+        xbard->p_to_target[tgtid_xicu]          (signal_vci_tgt_d_xicu);
+        xbard->p_to_target[tgtid_mdma]          (signal_vci_tgt_d_mdma);
           
-        xbard->p_to_initiator[nprocs]  		(signal_vci_ini_d_mdma);
+        xbard->p_to_initiator[nprocs]           (signal_vci_ini_d_mdma);
 
         for ( size_t p=0 ; p<nprocs ; p++)
         {
-            xbard->p_to_initiator[p]		(signal_vci_ini_d_proc[p]);
-        }
-
-	if ( io == true )
-	{
-            xbard->p_to_target[tgtid_mtty]  	(signal_vci_tgt_d_mtty);
-            xbard->p_to_target[tgtid_brom]  	(signal_vci_tgt_d_brom);
-            xbard->p_to_target[tgtid_bdev]  	(signal_vci_tgt_d_bdev);
-            xbard->p_to_target[tgtid_fbuf]  	(signal_vci_tgt_d_fbuf);
+            xbard->p_to_initiator[p]            (signal_vci_ini_d_proc[p]);
+        }
+
+        if ( io == true )
+        {
+            xbard->p_to_target[tgtid_mtty]      (signal_vci_tgt_d_mtty);
+            xbard->p_to_target[tgtid_brom]      (signal_vci_tgt_d_brom);
+            xbard->p_to_target[tgtid_bdev]      (signal_vci_tgt_d_bdev);
+            xbard->p_to_target[tgtid_fbuf]      (signal_vci_tgt_d_fbuf);
             
-            xbard->p_to_initiator[nprocs+1]  	(signal_vci_ini_d_bdev);
-	}
+            xbard->p_to_initiator[nprocs+1]     (signal_vci_ini_d_bdev);
+        }
         
         // CROSSBAR coherence
-        xbarc->p_clk                    	(this->p_clk);
-        xbarc->p_resetn                 	(this->p_resetn);
-        xbarc->p_initiator_to_up        	(signal_vci_l2g_c);
-        xbarc->p_target_to_up           	(signal_vci_g2l_c);
-        xbarc->p_to_initiator[nprocs]  		(signal_vci_ini_c_memc);
-        xbarc->p_to_target[nprocs]     		(signal_vci_tgt_c_memc);
+        xbarc->p_clk                            (this->p_clk);
+        xbarc->p_resetn                         (this->p_resetn);
+        xbarc->p_initiator_to_up                (signal_vci_l2g_c);
+        xbarc->p_target_to_up                   (signal_vci_g2l_c);
+        xbarc->p_to_initiator[nprocs]           (signal_vci_ini_c_memc);
+        xbarc->p_to_target[nprocs]              (signal_vci_tgt_c_memc);
         for ( size_t p=0 ; p<nprocs ; p++)
         {
-            xbarc->p_to_target[p]       	(signal_vci_tgt_c_proc[p]);
-            xbarc->p_to_initiator[p]    	(signal_vci_ini_c_proc[p]);
+            xbarc->p_to_target[p]               (signal_vci_tgt_c_proc[p]);
+            xbarc->p_to_initiator[p]            (signal_vci_ini_c_proc[p]);
         }
 
@@ -392,59 +395,59 @@
         for ( size_t p=0 ; p<nprocs ; p++)
         {
-            proc[p]->p_clk              	(this->p_clk);
-            proc[p]->p_resetn           	(this->p_resetn);
-            proc[p]->p_vci_ini_d        	(signal_vci_ini_d_proc[p]);
-            proc[p]->p_vci_ini_c        	(signal_vci_ini_c_proc[p]);
-            proc[p]->p_vci_tgt_c          	(signal_vci_tgt_c_proc[p]);
-            proc[p]->p_irq[0]           	(signal_proc_it[p]);
+            proc[p]->p_clk                      (this->p_clk);
+            proc[p]->p_resetn                   (this->p_resetn);
+            proc[p]->p_vci_ini_d                (signal_vci_ini_d_proc[p]);
+            proc[p]->p_vci_ini_c                (signal_vci_ini_c_proc[p]);
+            proc[p]->p_vci_tgt_c                (signal_vci_tgt_c_proc[p]);
+            proc[p]->p_irq[0]                   (signal_proc_it[p]);
             for ( size_t j = 1 ; j < 6 ; j++ )
             {
-                proc[p]->p_irq[j]       	(signal_false);
+                proc[p]->p_irq[j]               (signal_false);
             }
         }
         
         // XICU
-        xicu->p_clk                     	(this->p_clk);
-        xicu->p_resetn                  	(this->p_resetn);
-        xicu->p_vci                     	(signal_vci_tgt_d_xicu);
+        xicu->p_clk                             (this->p_clk);
+        xicu->p_resetn                          (this->p_resetn);
+        xicu->p_vci                             (signal_vci_tgt_d_xicu);
         for ( size_t p=0 ; p<nprocs ; p++)
         {
-            xicu->p_irq[p]              	(signal_proc_it[p]);
+            xicu->p_irq[p]                      (signal_proc_it[p]);
         }
         for ( size_t p=0 ; p<nprocs ; p++)
         {
-            xicu->p_hwi[p]			(signal_irq_mdma[p]);
+            xicu->p_hwi[p]                      (signal_irq_mdma[p]);
         }
         for ( size_t x=nprocs ; x<4 ; x++)
         {
-            xicu->p_hwi[x]			(signal_false);
+            xicu->p_hwi[x]                      (signal_false);
         }
         if ( io == true )
-	{
-            xicu->p_hwi[4]			(signal_irq_tty0);
-            xicu->p_hwi[5]			(signal_irq_tty1);
-            xicu->p_hwi[6]			(signal_irq_tty2);
-            xicu->p_hwi[7]			(signal_irq_tty3);
-            xicu->p_hwi[8]			(signal_irq_bdev);
-	}
+        {
+            xicu->p_hwi[4]                      (signal_irq_tty0);
+            xicu->p_hwi[5]                      (signal_irq_tty1);
+            xicu->p_hwi[6]                      (signal_irq_tty2);
+            xicu->p_hwi[7]                      (signal_irq_tty3);
+            xicu->p_hwi[8]                      (signal_irq_bdev);
+        }
 
         // MEMC
-        memc->p_clk                     	(this->p_clk);
-        memc->p_resetn                  	(this->p_resetn);
-        memc->p_vci_ixr                 	(signal_vci_xram);
-        memc->p_vci_tgt                 	(signal_vci_tgt_d_memc);
-        memc->p_vci_ini                 	(signal_vci_ini_c_memc);
-        memc->p_vci_tgt_cleanup         	(signal_vci_tgt_c_memc);
+        memc->p_clk                             (this->p_clk);
+        memc->p_resetn                          (this->p_resetn);
+        memc->p_vci_ixr                         (signal_vci_xram);
+        memc->p_vci_tgt                         (signal_vci_tgt_d_memc);
+        memc->p_vci_ini                         (signal_vci_ini_c_memc);
+        memc->p_vci_tgt_cleanup                 (signal_vci_tgt_c_memc);
 
         // XRAM
-        xram->p_clk                     	(this->p_clk);
-        xram->p_resetn                  	(this->p_resetn);
-        xram->p_vci                 		(signal_vci_xram);
+        xram->p_clk                             (this->p_clk);
+        xram->p_resetn                          (this->p_resetn);
+        xram->p_vci                             (signal_vci_xram);
 
         // CDMA
-        mdma->p_clk                       	(this->p_clk);
-        mdma->p_resetn                    	(this->p_resetn);
-        mdma->p_vci_target                	(signal_vci_tgt_d_mdma);
-        mdma->p_vci_initiator             	(signal_vci_ini_d_mdma);
+        mdma->p_clk                             (this->p_clk);
+        mdma->p_resetn                          (this->p_resetn);
+        mdma->p_vci_target                      (signal_vci_tgt_d_mdma);
+        mdma->p_vci_initiator                   (signal_vci_ini_d_mdma);
         for (size_t p=0 ; p<nprocs ; p++)
         {
@@ -452,33 +455,33 @@
         }
 
-	// Components in IO cluster
-
-	if ( io == true )
-	{
-       	    // BDEV            
-	    bdev->p_clk                      	(this->p_clk);
-       	    bdev->p_resetn                   	(this->p_resetn);
-       	    bdev->p_irq                      	(signal_irq_bdev);
-       	    bdev->p_vci_target               	(signal_vci_tgt_d_bdev);
-       	    bdev->p_vci_initiator            	(signal_vci_ini_d_bdev);
-
-       	    // FBUF
-       	    fbuf->p_clk                       	(this->p_clk);
-       	    fbuf->p_resetn                    	(this->p_resetn);
-       	    fbuf->p_vci                       	(signal_vci_tgt_d_fbuf);
-
-       	    // BROM
-       	    brom->p_clk                       	(this->p_clk);
-       	    brom->p_resetn                    	(this->p_resetn);
-       	    brom->p_vci                       	(signal_vci_tgt_d_brom);
+        // Components in IO cluster
+
+        if ( io == true )
+        {
+            // BDEV            
+            bdev->p_clk                         (this->p_clk);
+            bdev->p_resetn                      (this->p_resetn);
+            bdev->p_irq                         (signal_irq_bdev);
+            bdev->p_vci_target                  (signal_vci_tgt_d_bdev);
+            bdev->p_vci_initiator               (signal_vci_ini_d_bdev);
+
+            // FBUF
+            fbuf->p_clk                         (this->p_clk);
+            fbuf->p_resetn                      (this->p_resetn);
+            fbuf->p_vci                         (signal_vci_tgt_d_fbuf);
+
+            // BROM
+            brom->p_clk                         (this->p_clk);
+            brom->p_resetn                      (this->p_resetn);
+            brom->p_vci                         (signal_vci_tgt_d_brom);
 
             // MTTY
-            mtty->p_clk                       	(this->p_clk);
-            mtty->p_resetn                    	(this->p_resetn);
-            mtty->p_vci                       	(signal_vci_tgt_d_mtty);
-            mtty->p_irq[0]           		(signal_irq_tty0);
-            mtty->p_irq[1]           		(signal_irq_tty1);
-            mtty->p_irq[2]           		(signal_irq_tty2);
-            mtty->p_irq[3]           		(signal_irq_tty3);
+            mtty->p_clk                         (this->p_clk);
+            mtty->p_resetn                      (this->p_resetn);
+            mtty->p_vci                         (signal_vci_tgt_d_mtty);
+            mtty->p_irq[0]                      (signal_irq_tty0);
+            mtty->p_irq[1]                      (signal_irq_tty1);
+            mtty->p_irq[2]                      (signal_irq_tty2);
+            mtty->p_irq[3]                      (signal_irq_tty3);
         }
 } // end constructor